package ru.dbotthepony.mc.otm.compat.vanilla

import net.minecraft.world.Container
import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.item.ItemStack
import ru.dbotthepony.mc.otm.container.EnhancedContainer
import ru.dbotthepony.mc.otm.menu.MatteryMenuSlot
import ru.dbotthepony.mc.otm.menu.makeSlots

class MatteryShulkerBoxMenu(
	containerId: Int,
	inventory: Inventory,
	container: Container = EnhancedContainer(27)
) : AbstractVanillaChestMenu(VanillaMenuTypes.SHULKER_BOX, containerId, inventory, container) {
	override val containerSlots = makeSlots(container, ::Slot)
	override val rows: Int
		get() = 3
	override val columns: Int
		get() = 9

	init {
		container.startOpen(player)
		addStorageSlot(containerSlots)
		addInventorySlots()
	}

	class Slot(container: Container, slot: Int) : MatteryMenuSlot(container, slot) {
		override fun mayPlace(stack: ItemStack): Boolean {
			return super.mayPlace(stack) && stack.item.canFitInsideContainerItems()
		}
	}
}
